#include <cstdio>
#include <cstring>
#include "Prod.hpp"

//----------------------------------------------------------------------------------------------------------------------
Product::Product(const char* name, int count, int cost_per_unit) :
  name_(),
  count_(count),
  cost_per_unit_(cost_per_unit),
  total_cost_(-1)
{
  strncpy(name_, name, 31);
  name_[31] = 0;

  if (count_ < 0)
  {
    count_ = 0;
  }

  if (cost_per_unit_ < 0)
  {
    cost_per_unit_ = 0;
  }

  counter_++;
}

//----------------------------------------------------------------------------------------------------------------------
Product::Product(Product& prod) :
  name_(),
  count_(prod.count_),
  cost_per_unit_(prod.cost_per_unit_),
  total_cost_(prod.total_cost_)
{
  strcpy(name_, prod.name_);
  counter_++;
}

//----------------------------------------------------------------------------------------------------------------------
void Product::setName(const char* name)
{
  strncpy(name_, name, 31);
  name_[31] = 0;
}

//----------------------------------------------------------------------------------------------------------------------
void Product::setCount(int count)
{
  count_ = count;
  if (count_ < 0)
  {
    count_ = 0;
  }
}

//----------------------------------------------------------------------------------------------------------------------
void Product::setCostPerUnit(int cost_per_unit)
{
  cost_per_unit_ = cost_per_unit;
  if (cost_per_unit_ < 0)
  {
    cost_per_unit_ = 0;
  }
}

//----------------------------------------------------------------------------------------------------------------------
void Product::increaseCount(int increment)
{
  if (increment >= 1)
    count_ += increment;
}

//----------------------------------------------------------------------------------------------------------------------
void Product::updateTotalCost()
{
  total_cost_ = cost_per_unit_ * count_;
}

//----------------------------------------------------------------------------------------------------------------------
void Product::print()
{
  printf("%s\n", name_);
  printf("\tCount: %d  -  "
         "Cost: %d  -  "
         "Total Cost: %d\n", count_, cost_per_unit_, total_cost_);
}

//----------------------------------------------------------------------------------------------------------------------
void Product::merge(Product& prod)
{
  if (strcmp(name_, prod.name_) != 0)
    return;

  if (cost_per_unit_ != prod.cost_per_unit_)
    return;

  count_ += prod.count_;
  prod.count_ = 0;
  updateTotalCost();
  prod.updateTotalCost();
}
