#ifndef PROD_HPP
#define PROD_HPP

class Product
{
  private:

    static int counter_;

    char name_[32];
    int count_;

    int cost_per_unit_;
    int total_cost_;

  public:

    static int getCounter() { return counter_; }

    Product() { counter_++; };
    Product(const char* name, int count, int cost_per_unit);
    Product(Product& prod);
    ~Product() { counter_--; }

    char* getName() { return name_; }
    int getCount() { return count_; }
    int getCostPerUnit() { return cost_per_unit_; }
    int getTotalCost() { return total_cost_; }

    void setName(const char* name);
    void setCount(int count);
    void setCostPerUnit(int cost_per_unit);

    void increaseCount(int value);
    void updateTotalCost();
    void print();

    void merge(Product& prod);
};

inline int Product::counter_ = 0;

#endif // PROD_HPP
