#include <cstdio>
#include "Prod.hpp"

// compile with: clang++ -std=c++17 -Wall -o prod Prod.cpp main.cpp -g

int main(void)
{
  {
    Product prod_stack("Zwiebel", 5, 3);
    Product* prod_heap = new Product("Salami", 4, 7);
    printf("Number of products: %d\n", Product::getCounter());

    Product* prod_ptr = &prod_stack;
    Product& prod_ref = *prod_heap;
    printf("Number of products: %d\n", Product::getCounter());

    Product prod_copy(prod_ref);
    Product* prod_copy_heap = new Product(*prod_ptr);
    printf("Number of products: %d\n", Product::getCounter());

    delete prod_copy_heap;
    delete prod_heap;
    printf("Number of products: %d\n", Product::getCounter());
  }

  printf("Number of products: %d\n", Product::getCounter());
  return 0;
}
