#include <cstdio>
#include <cstring>

// TODO: destructor (free memory allocated on the heap (for name_))
// TODO: copy constructor (implement deep copy)

class Pig {
  char* name_; // longer names now supported (compared to `char name_[10];`)
  unsigned age_;
 
  public:
    Pig(const char* name, unsigned age)
      : name_{ new char[strlen(name) + 1] }, age_{age}
    {
      strcpy(name_, name);
    }
    void drink() { printf("%s drinks\n", name_); }
    void bath() { printf("Bath! :D\n"); }
    unsigned getAge() { return age_; }
    void setAge(unsigned age) { age_ = age; }
};

class Cat { // not a pig
  char* name_;
  unsigned age_;

  public:
    Cat(const char* name, unsigned age)
      : name_{ new char[strlen(name) + 1] }, age_{age}
    {
      strcpy(name_, name);
    }
    void drink() { printf("%s drinks\n", name_); }
    void play() { printf("Play! :D\n"); } // cats play and don't take a bath
    unsigned getAge() { return age_; }
    void setAge(unsigned age) { age_ = age; }
};

int main()
{
  Pig pig{ "Babe", 0 };
  pig.bath();
  pig.drink();
  Cat cat{ "Grumpy", 7 };
  cat.play();
  // cat.bath(); // <-- error: no member named 'bath' in 'Cat' (Cats don't enjoy taking a bath – only pigs do)
  cat.drink();
  return 0;
}
