#include <iostream>
#include <string>
#include <memory>
 
struct SuperHero {
  public:
    SuperHero(std::string name, std::string phrase) : name_(name), 
      phrase_(phrase) 
    { 
      std::cout << name_ << " wurde erzeugt" << std::endl; 
    };
 
    ~SuperHero() 
    { 
      std::cout << name_ << " wurde zerstört" << std::endl; 
    };
 
    void SayPhrase() 
    { 
      std::cout << phrase_ << std::endl; 
    };
 
  private:
    std::string phrase_; 
    std::string name_;
};
 
int main()
{
  std::unique_ptr<SuperHero> s1(new SuperHero("Batman", "I am Batman!"));
  std::unique_ptr<SuperHero> s2 = std::make_unique<SuperHero>("Iron Man", 
    "I love you 3000!");
 
  s1->SayPhrase(); //I am Batman!
  s2->SayPhrase(); //I love you 3000!
 
  return 0;
}