#include <iostream>
#include <string>
#include <memory>
 
struct SuperHero {
  public:
    SuperHero(std::string name) : name_(name)
    { 
      std::cout << name_ << " wurde erzeugt" << std::endl; 
    };
 
    ~SuperHero() 
    { 
      std::cout << name_ << " wurde zerstört" << std::endl; 
    };
 
    void SayPhrase() 
    { 
      std::cout << phrase_ << std::endl; 
    };
 
  private:
    std::string phrase_; 
    std::string name_;
};

int main()
{
  std::shared_ptr<SuperHero> s1 = std::make_shared<SuperHero>("Batman");
  {
    std::shared_ptr<SuperHero> s2(s1);
    std::cout << s1.use_count() << std::endl; //2
  }
  std::cout << s1.use_count() << std::endl; //1
 
  return 0;
}