#include <iostream>
#include <string>
#include <memory>

struct SuperHero {
  std::string name_;
  SuperHero(std::string name) : name_(name) 
  { 
    std::cout << name_ << " wurde erzeugt" << std::endl; 
  };
  
  ~SuperHero() 
  { 
    std::cout << name_ << " wurde zerstört" << std::endl; 
  };

  std::string GetName() const 
  {
    return name_;
  }

};
 
int main()
{
  auto hero = std::make_shared<SuperHero>("Aquaman");
  std::weak_ptr<SuperHero> w_hero(hero);
 
  auto new_hero = w_hero.lock(); //Umwandlung in std::shared_ptr
 
  new_hero = nullptr;
  hero = nullptr;  
  if(w_hero.expired())
  {
    std::cout << "Kein Aquaman mehr :-(";
  }
  return 0;
}