#include <iostream>
#include <string>
#include <memory>

struct SuperHero {
  std::string name_;
  SuperHero(std::string name) : name_(name) 
  { 
    std::cout << name_ << " wurde erzeugt" << std::endl; 
  };
  
  ~SuperHero() 
  { 
    std::cout << name_ << " wurde zerstört" << std::endl; 
  };

  std::string GetName() const 
  {
    return name_;
  }

};
 
int main()
{
  auto hero = std::make_shared<SuperHero>("Aquaman");
  std::weak_ptr<SuperHero> w_hero(hero);
  //std::cout << w_hero->GetName(); --> Zugriff nicht möglich!
 
  std::cout << w_hero.use_count() << std::endl; //1
 
  auto new_hero = w_hero.lock(); //Umwandlung in std::shared_ptr
  std::cout << new_hero->GetName();
 
  std::cout << w_hero.use_count() << std::endl; //2
 
  return 0;
}